function varargout = Brno(varargin)
% BRNO MATLAB code for Brno.fig
%      BRNO, by itself, creates a new BRNO or raises the existing
%      singleton*.
%
%      H = BRNO returns the handle to a new BRNO or the handle to
%      the existing singleton*.
%
%      BRNO('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BRNO.M with the given input arguments.
%
%      BRNO('Property','Value',...) creates a new BRNO or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Brno_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Brno_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Brno



% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Brno_OpeningFcn, ...
                   'gui_OutputFcn',  @Brno_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Brno is made visible.
function Brno_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Brno (see VARARGIN)

% Choose default command line output for Brno
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Brno wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Brno_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%% Paths and variables
row_offset = 22;
col_offset = 1;

%% Load the data
[data] = csvread('Brno.csv', row_offset);
t = data(:, 1);
p = data(:, 2);
h = data(:, 3);


%% Detect the pulses
[~, p1] = findpeaks(p,'MinPeakHeight', max(p)/2);
changes = diff(p1);
[~, p2] = findpeaks(changes,'MinPeakHeight', max(changes)/2);
borders = p1([1; p2 + 1]);

%% Segment the signal
num_signals = length(borders - 1);
num_samples = min(diff(borders));
signals = zeros(num_signals, num_samples);

for i = 1:(length(borders) - 2)
    selection = h(borders(i):borders(i + 1) - 1);
    signals(i, :) = selection(1:num_samples);
end


 
imagesc(signals)
colorbar
xlabel('Vzorky')
ylabel('Repetice')
set(gca,'Ydir','Normal')


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%% Paths and variables
row_offset = 22;
col_offset = 1;

%% Load the data
[data] = csvread('Brno.csv', row_offset);
t = data(:, 1);
p = data(:, 2);
h = data(:, 3);


%% Detect the pulses
[~, p1] = findpeaks(p,'MinPeakHeight', max(p)/2);
changes = diff(p1);
[~, p2] = findpeaks(changes,'MinPeakHeight', max(changes)/2);
borders = p1([1; p2 + 1]);

%% Segment the signal
num_signals = length(borders - 1);
num_samples = min(diff(borders));
signals = zeros(num_signals, num_samples);

for i = 1:(length(borders) - 2)
    selection = h(borders(i):borders(i + 1) - 1);
    signals(i, :) = selection(1:num_samples);
end

row_char = signals(1,:);
impulse_char = impz(row_char);
plot(impulse_char)
xlabel('n')
ylabel('h(n)')
grid on


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%% Paths and variables
row_offset = 22;
col_offset = 1;

%% Load the data
[data] = csvread('Brno.csv', row_offset);
t = data(:, 1);
p = data(:, 2);
h = data(:, 3);


%% Detect the pulses
[~, p1] = findpeaks(p,'MinPeakHeight', max(p)/2);
changes = diff(p1);
[~, p2] = findpeaks(changes,'MinPeakHeight', max(changes)/2);
borders = p1([1; p2 + 1]);

%% Segment the signal
num_signals = length(borders - 1);
num_samples = min(diff(borders));
signals = zeros(num_signals, num_samples);

for i = 1:(length(borders) - 2)
    selection = h(borders(i):borders(i + 1) - 1);
    signals(i, :) = selection(1:num_samples);
end

for j= 1:(num_signals)-2
    row_char=signals(j,:);
    imp_char(j,:)= impz(row_char);
    
end

impuls_char=imp_char';
plot(impuls_char)
xlabel('n')
ylabel('h(n)')
grid on


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%% Paths and variables
row_offset = 22;
col_offset = 1;

%% Load the data
[data] = csvread('Brno.csv', row_offset);
t = data(:, 1);
p = data(:, 2);
h = data(:, 3);


%% Detect the pulses
[~, p1] = findpeaks(p,'MinPeakHeight', max(p)/2);
changes = diff(p1);
[~, p2] = findpeaks(changes,'MinPeakHeight', max(changes)/2);
borders = p1([1; p2 + 1]);

%% Segment the signal
num_signals = length(borders - 1);
num_samples = min(diff(borders));
signals = zeros(num_signals, num_samples);

for i = 1:(length(borders) - 2)
    selection = h(borders(i):borders(i + 1) - 1);
    signals(i, :) = selection(1:num_samples);
end

%% Move mean
m = movmean(signals,2500,1);
c = m-signals;
imagesc(c)
colorbar
xlabel('Vzdlenost [m]')
ylabel('Repetice')
set(gca,'Ydir','Normal')


% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%% Paths and variables
row_offset = 22;
col_offset = 1;

%% Load the data
[data] = csvread('Brno.csv', row_offset);
t = data(:, 1);
p = data(:, 2);
h = data(:, 3);


%% Detect the pulses
[~, p1] = findpeaks(p,'MinPeakHeight', max(p)/2);
changes = diff(p1);
[~, p2] = findpeaks(changes,'MinPeakHeight', max(changes)/2);
borders = p1([1; p2 + 1]);

%% Segment the signal
num_signals = length(borders - 1);
num_samples = min(diff(borders));
signals = zeros(num_signals, num_samples);

for i = 1:(length(borders) - 2)
    selection = h(borders(i):borders(i + 1) - 1);
    signals(i, :) = selection(1:num_samples);
end

%% bandpass

order = 5;
fs = 2000;
fcutlow = 80;
fcuthigh = 430;
[b,a] = butter(order,[fcutlow,fcuthigh]/(fs/2), 'bandpass');
band = filter(b,a,signals);
imagesc(band)
colorbar
xlabel('Vzdlenost [m]')
ylabel('Repetice')
set(gca,'Ydir','Normal')


% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%% Paths and variables
row_offset = 22;
col_offset = 1;

%% Load the data
[data] = csvread('Brno.csv', row_offset);
t = data(:, 1);
p = data(:, 2);
h = data(:, 3);

%% Detect the pulses
[~, p1] = findpeaks(p,'MinPeakHeight', max(p)/2);
changes = diff(p1);
[~, p2] = findpeaks(changes,'MinPeakHeight', max(changes)/2);
borders = p1([1; p2 + 1]);

%% Segment the signal
num_signals = length(borders - 1);
num_samples = min(diff(borders));
signals = zeros(num_signals, num_samples);

for i = 1:(length(borders) - 2)
    selection = h(borders(i):borders(i + 1) - 1);
    signals(i, :) = selection(1:num_samples);
end

%% korelace
L = 400;
acf=ifft(fft(signals,L).*fft(signals,L));
imagesc(acf)
colorbar
xlabel('Vzdlenost [m]')
ylabel('Repetice')
set(gca,'Ydir','Normal')
